%========================================================================================
% trajektorien - Callback-Datei fr trajektorien.fig.
%========================================================================================
% TRAJEKTORIEN M-file for Trajektorien.fig
%      TRAJEKTORIEN, by itself, creates a new TRAJEKTORIEN or raises the existing
%      singleton*.
%
%      H = TRAJEKTORIEN returns the handle to a new TRAJEKTORIEN or the handle to
%      the existing singleton*.
%
%      TRAJEKTORIEN('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TRAJEKTORIEN.M with the given input arguments.
%
%      TRAJEKTORIEN('Property','Value',...) creates a new TRAJEKTORIEN or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Trajektorien_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Trajektorien_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES
%========================================================================================
%  Autor:            Thomas Lens
%  Letzte nderung:  21.12.2004
%========================================================================================
function varargout = trajektorien(varargin)
% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @trajektorien_OpeningFcn, ...
                   'gui_OutputFcn',  @trajektorien_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT



%========================================================================================
% trajektorien_OpeningFcn
%========================================================================================
% --- Executes just before trajektorien is made visible.
%========================================================================================
function trajektorien_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to trajektorien (see VARARGIN)

% Choose default command line output for trajektorien
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

if strcmp(get(hObject,'Visible'),'off')
    initialize_gui(hObject, handles);
end

% UIWAIT makes trajektorien wait for user response (see UIRESUME)
% uiwait(handles.figure1);



%========================================================================================
% trajektorien_OutputFcn
%========================================================================================
% --- Outputs from this function are returned to the command line.
%========================================================================================
function varargout = trajektorien_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



%========================================================================================
% initialize_gui
%========================================================================================
function initialize_gui(fig_handle, handles)
% -== Systemgleichung ==- %
data.sDX1 = '-sin(x1)';
data.sDX2 = '-sin(x2)';
% -== Allgemeine Parameter ==- %
data.vBereich = [-3, 3, -3, 3];
data.vLaufzeit = [-2, 8];
data.bNeuesDiagramm = logical(1);
% -== Anfangswerte ==- %
data.bAnfangswertGitter = logical(0);
data.bAnfangswertRechteck = logical(1);
data.bAnfangswertPunkt = logical(0);
data.vAnfangswertBereichGitter = [-2.8 2.8 -2.8 2.8];
data.vAnzahlAnfangswerteGitter = [5, 5];
data.vAnfangswertBereichRechteck = [-2.8 2.8 -2.8 2.8];
data.vAnzahlAnfangswerteRechteck = [7, 7];
data.vAnfangswertBereichPunkt = [1, 1];
% -== Pfeile ==- %
data.LaengePfeil = 1.5;


% -== Parameter speichern ==- %
setappdata(fig_handle, 'Parameter', data);

% -== Aktuelle Daten anzeigen ==- %
showdata(handles, data);






%========================================================================================
% showdata - Mit aktueller Datenstruktur Textfelder etc. aktualisieren
%========================================================================================
function showdata(handles, data)
% -== Parameter anzeigen, Textfelder initialisieren - Systemgleichungen ==- %
set(handles.edit_Systemgleichung1, 'String', data.sDX1);
set(handles.edit_Systemgleichung2, 'String', data.sDX2);
set(handles.edit_Darstellungsbereich, 'String', ['[  ' sprintf('%g  ', data.vBereich) ']']);
set(handles.edit_Laufzeit, 'String', ['[  ' sprintf('%g  ', data.vLaufzeit) ']']);
set(handles.checkbox_NeuesDiagramm, 'Value', data.bNeuesDiagramm);
% -== Parameter anzeigen, Textfelder initialisieren - Anfangswertparameter ==- %
set(handles.radiobutton_Gitter, 'Value', data.bAnfangswertGitter);
set(handles.radiobutton_Rechteck, 'Value', data.bAnfangswertRechteck);
set(handles.radiobutton_Punkt, 'Value', data.bAnfangswertPunkt);
set(handles.edit_AnfangswertBereichGitter, 'String', ['[  ' sprintf('%g  ', data.vAnfangswertBereichGitter) ']']);
set(handles.edit_AnfangswertBereichRechteck, 'String', ['[  ' sprintf('%g  ', data.vAnfangswertBereichRechteck) ']']);
set(handles.edit_AnfangswertBereichPunkt, 'String', ['[  ' sprintf('%g  ', data.vAnfangswertBereichPunkt) ']']);
set(handles.edit_AnzahlAnfangswerte_Gitter, 'String', ['[  ' sprintf('%g  ', data.vAnzahlAnfangswerteGitter) ']']);
set(handles.edit_AnzahlAnfangswerte_Rechteck, 'String', ['[  ' sprintf('%g  ', data.vAnzahlAnfangswerteRechteck) ']']);
% -== Parameter anzeigen, Textfelder initialisieren - Pfeilparameter ==- %
set(handles.edit_LaengePfeil, 'String', sprintf('%g', data.LaengePfeil));

% -== Inaktive Textfelder setzen ==- %
if (data.bAnfangswertRechteck == logical(1))
  set(handles.edit_AnfangswertBereichRechteck, 'Enable', 'on');
  set(handles.edit_AnzahlAnfangswerte_Rechteck, 'Enable', 'on');
else
  set(handles.edit_AnfangswertBereichRechteck, 'Enable', 'off');
  set(handles.edit_AnzahlAnfangswerte_Rechteck, 'Enable', 'off');
end
if (data.bAnfangswertGitter == logical(1))
  set(handles.edit_AnfangswertBereichGitter, 'Enable', 'on');
  set(handles.edit_AnzahlAnfangswerte_Gitter, 'Enable', 'on');
else
  set(handles.edit_AnfangswertBereichGitter, 'Enable', 'off');
  set(handles.edit_AnzahlAnfangswerte_Gitter, 'Enable', 'off');
end
if (data.bAnfangswertPunkt == logical(1))
  set(handles.edit_AnfangswertBereichPunkt, 'Enable', 'on');
else
  set(handles.edit_AnfangswertBereichPunkt, 'Enable', 'off');
end

%========================================================================================
% edit_Systemgleichung1_CreateFcn
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function edit_Systemgleichung1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Systemgleichung1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%========================================================================================
% edit_Systemgleichung1_Callback
%========================================================================================
function edit_Systemgleichung1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Systemgleichung1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
sDX1 = get(hObject, 'String');                    % Eingabe holen.
data = getappdata(gcbf, 'Parameter');             % Parameter speichern.
% -== Eingabe prfen ==- %
x1 = 1; x2 = 1;
try
  eval([sDX1 ';']);
catch 
  msgbox('Parameter sDX1 ist fehlerhaft. Bitte nur Variablen x1 und x2 benutzen.', 'Fehlerhafte Eingabe', 'error'); 
  sDX1 = data.sDX1;
end
% -== Parameter speichern ==-
data.sDX1 = sDX1;
setappdata(gcbf, 'Parameter', data);
set(hObject, 'String', data.sDX1);                % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% pushbutton_Berechnen_Callback
%========================================================================================
% --- Executes on button press in pushbutton_Berechnen.
%========================================================================================
function pushbutton_Berechnen_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_Berechnen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

data = getappdata(gcbf, 'Parameter');

% sParameter = {
%   data.sDX1,
%   data.sDX2,
%   num2str( data.vBereich ),
%   num2str( data.vLaufzeit ),
%   num2str( data.bNeuesDiagramm),
%   num2str( data.bAnfangswertGitter ),
%   num2str( data.bAnfangswertRechteck ),
%   num2str( data.bAnfangswertPunkt ),
%   num2str( data.vAnfangswertBereichGitter ),
%   num2str( data.vAnfangswertBereichRechteck ),
%   num2str( data.vAnfangswertBereichPunkt ),
%   num2str( data.vAnzahlAnfangswerteGitter ),
%   num2str( data.vAnzahlAnfangswerteRechteck ),
%   num2str( data.LaengePfeil),
% };
% msgbox(sParameter);

% -== Mit den vorhandenen Parametern die Trajektorien berechnen und plotten ==-
if (data.bAnfangswertGitter == logical(1))
  plottrajektorien_nichtlinear( data.sDX1, data.sDX2, data.vBereich, data.vLaufzeit, data.bNeuesDiagramm, ... 
                            logical(1), data.vAnfangswertBereichGitter, data.vAnzahlAnfangswerteGitter,...
                            data.LaengePfeil )
elseif (data.bAnfangswertRechteck == logical(1))
  plottrajektorien_nichtlinear( data.sDX1, data.sDX2, data.vBereich, data.vLaufzeit, data.bNeuesDiagramm, ... 
                            logical(0), data.vAnfangswertBereichRechteck, data.vAnzahlAnfangswerteRechteck,...
                            data.LaengePfeil )
elseif (data.bAnfangswertPunkt == logical(1))
  vAnfangswertBereich = [data.vAnfangswertBereichPunkt(1), data.vAnfangswertBereichPunkt(1), data.vAnfangswertBereichPunkt(2), data.vAnfangswertBereichPunkt(2)];
  plottrajektorien_nichtlinear( data.sDX1, data.sDX2, data.vBereich, data.vLaufzeit, data.bNeuesDiagramm, ... 
                            logical(0), vAnfangswertBereich, [1 1],...
                            data.LaengePfeil )
end



%========================================================================================
% edit_Systemgleichung2_CreateFcn
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function edit_Systemgleichung2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Systemgleichung2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%========================================================================================
% edit_Systemgleichung2_Callback
%========================================================================================
function edit_Systemgleichung2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Systemgleichung2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_Systemgleichung2 as text
%        str2double(get(hObject,'String')) returns contents of edit_Systemgleichung2 as a double
sDX2 = get(hObject, 'String');                    % Eingabe holen.
data = getappdata(gcbf, 'Parameter');             % Parameter speichern.
% -== Eingabe prfen ==- %
x1 = 1; x2 = 1;
try
  eval([sDX2 ';']);
catch 
  msgbox('Parameter sDX2 ist fehlerhaft. Bitte nur Variablen x1 und x2 benutzen.', 'Fehlerhafte Eingabe', 'error'); 
  sDX2 = data.sDX2;
end
% -== Parameter speichern ==-
data.sDX2 = sDX2;
setappdata(gcbf, 'Parameter', data);
set(hObject, 'String', data.sDX2);                % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% edit_Darstellungsbereich_CreateFcn
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function edit_Darstellungsbereich_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Darstellungsbereich (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%========================================================================================
% edit_Darstellungsbereich_Callback
%========================================================================================
function edit_Darstellungsbereich_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Darstellungsbereich (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
vBereich = str2num(get(hObject, 'String'));        % Eingabe holen und prfen.
data = getappdata(gcbf, 'Parameter');             % Datenstruktur holen.
if (~all(size(vBereich) == [1 4]))
  msgbox('Parameter fehlerhaft: Darstellungsbereich = [xmin, xmax, ymin, ymax]', 'Fehlerhafte Eingabe', 'error');
elseif ((vBereich(2) <= vBereich(1)) | (vBereich(4) <= vBereich(3)))
  msgbox('Parameter fehlerhaft: Darstellungsbereich = [xmin, xmax, ymin, ymax]', 'Fehlerhafte Eingabe', 'error');
else
  data.vBereich = vBereich;                         % Neuen Parameter speichern.
end
setappdata(gcbf, 'Parameter', data);
set(hObject, 'String', ['[  ' sprintf('%g  ', data.vBereich) ']']);   % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% edit_Laufzeit_CreateFcn
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function edit_Laufzeit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Laufzeit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%========================================================================================
% edit_Laufzeit_Callback
%========================================================================================
function edit_Laufzeit_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Laufzeit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
vLaufzeit = str2num(get(hObject, 'String'));        % Eingabe holen.
data = getappdata(gcbf, 'Parameter');             % Datenstruktur holen.
if (~all(size(vLaufzeit) == [1 2]))
  msgbox('Parameter fehlerhaft: Laufzeit = [tmin, tmax]', 'Fehlerhafte Eingabe', 'error');
elseif ((vLaufzeit(1) > 0) | (vLaufzeit(2) < 0))
  msgbox('Parameter fehlerhaft: Laufzeit = [tmin, tmax]', 'Fehlerhafte Eingabe', 'error');
else
  data.vLaufzeit = vLaufzeit;                         % Neuen Parameter speichern.
end
setappdata(gcbf, 'Parameter', data);
set(hObject, 'String', ['[  ' sprintf('%g  ', data.vLaufzeit) ']']);   % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% checkbox_NeuesDiagramm_Callback
%========================================================================================
% --- Executes on button press in checkbox_NeuesDiagramm.
%========================================================================================
function checkbox_NeuesDiagramm_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_NeuesDiagramm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
bNeuesDiagramm = get(hObject, 'Value');           % Eingabe holen.
data = getappdata(gcbf, 'Parameter');             % Parameter speichern.
data.bNeuesDiagramm = bNeuesDiagramm;
setappdata(gcbf, 'Parameter', data);
set(hObject, 'Value', data.bNeuesDiagramm);  % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% edit_LaengePfeil_CreateFcn
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function edit_LaengePfeil_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_LaengePfeil (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%========================================================================================
% edit_LaengePfeil_Callback
%========================================================================================
function edit_LaengePfeil_Callback(hObject, eventdata, handles)
% hObject    handle to edit_LaengePfeil (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
LaengePfeil = str2num(get(hObject, 'String'));        % Eingabe holen.
data = getappdata(gcbf, 'Parameter');             % Datenstruktur holen.
if (~all(size(LaengePfeil) == [1 1]))
  msgbox('Parameter fehlerhaft: LaengePfeil >= 0', 'Fehlerhafte Eingabe', 'error');
elseif (LaengePfeil < 0)
  msgbox('Parameter fehlerhaft: LaengePfeil >= 0', 'Fehlerhafte Eingabe', 'error');
else
  data.LaengePfeil = LaengePfeil;                        % Neuen Parameter speichern.
end
setappdata(gcbf, 'Parameter', data);
set(hObject, 'String', sprintf('%g', data.LaengePfeil));   % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% edit_AnfangswertBereichRechteck_CreateFcn
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function edit_AnfangswertBereichRechteck_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_AnfangswertbereichRechteck (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%========================================================================================
% edit_AnfangswertBereichRechteck_Callback
%========================================================================================
function edit_AnfangswertBereichRechteck_Callback(hObject, eventdata, handles)
% hObject    handle to edit_AnfangswertbereichRechteck (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
vAnfangswertBereich = str2num(get(hObject, 'String'));        % Eingabe holen.
data = getappdata(gcbf, 'Parameter');             % Datenstruktur holen.
if (~all(size(vAnfangswertBereich) == [1 4]))
  msgbox('Parameter fehlerhaft: Rechteck = [xmin, xmax, ymin, ymax]', 'Fehlerhafte Eingabe', 'error');  
elseif ((vAnfangswertBereich(2) < vAnfangswertBereich (1)) | (vAnfangswertBereich (4) < vAnfangswertBereich(3) > 0))
  msgbox('Parameter fehlerhaft: Rechteck = [xmin, xmax, ymin, ymax]', 'Fehlerhafte Eingabe', 'error');
else
  data.vAnfangswertBereichRechteck = vAnfangswertBereich;                        % Neuen Parameter speichern.
end
setappdata(gcbf, 'Parameter', data);
set(hObject, 'String', ['[  ' sprintf('%g  ', data.vAnfangswertBereichRechteck) ']']);   % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% edit_AnzahlAnfangswerte_Rechteck_CreateFcn
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function edit_AnzahlAnfangswerte_Rechteck_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_AnzahlAnfangswerte_Rechteck (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%========================================================================================
% edit_AnzahlAnfangswerte_Rechteck_Callback
%========================================================================================
function edit_AnzahlAnfangswerte_Rechteck_Callback(hObject, eventdata, handles)
% hObject    handle to edit_AnzahlAnfangswerte_Rechteck (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
vAnzahlAnfangswerte = str2num(get(hObject, 'String'));        % Eingabe holen.
data = getappdata(gcbf, 'Parameter');             % Datenstruktur holen.
if (~all(size(vAnzahlAnfangswerte) == [1 2]))
  msgbox('Parameter fehlerhaft: Anzahl Anfangswerte = [Nx, Ny]', 'Fehlerhafte Eingabe', 'error');
elseif (vAnzahlAnfangswerte(1) < 0) | (vAnzahlAnfangswerte(2) < 0)
  msgbox('Parameter fehlerhaft: Anzahl Anfangswerte = [Nx, Ny]', 'Fehlerhafte Eingabe', 'error');
else
  data.vAnzahlAnfangswerteRechteck = vAnzahlAnfangswerte;                        % Neuen Parameter speichern.
end
setappdata(gcbf, 'Parameter', data);
set(hObject, 'String', ['[  ' sprintf('%g  ', data.vAnzahlAnfangswerteRechteck) ']']);   % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% radiobutton_Gitter_Callback
%========================================================================================
% --- Executes on button press in radiobutton_Gitter.
%========================================================================================
function radiobutton_Gitter_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_Gitter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.radiobutton_Rechteck, 'Value', 0);
set(handles.radiobutton_Gitter, 'Value', 1);
set(handles.radiobutton_Punkt, 'Value', 0);

set(handles.edit_AnfangswertBereichRechteck, 'Enable', 'off');
set(handles.edit_AnzahlAnfangswerte_Rechteck, 'Enable', 'off');
set(handles.edit_AnfangswertBereichGitter, 'Enable', 'on');
set(handles.edit_AnzahlAnfangswerte_Gitter, 'Enable', 'on');
set(handles.edit_AnfangswertBereichPunkt, 'Enable', 'off');

data = getappdata(gcbf, 'Parameter');             % Parameter speichern.
data.bAnfangswertGitter = logical(1);
data.bAnfangswertRechteck = logical(0);
data.bAnfangswertPunkt = logical(0);
setappdata(gcbf, 'Parameter', data);



%========================================================================================
% radiobutton_Rechteck_Callback
%========================================================================================
% --- Executes on button press in radiobutton_Rechteck.
%========================================================================================
function radiobutton_Rechteck_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_Rechteck (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.radiobutton_Rechteck, 'Value', 1);    % Radiobuttons
set(handles.radiobutton_Gitter, 'Value', 0);
set(handles.radiobutton_Punkt, 'Value', 0);

set(handles.edit_AnfangswertBereichRechteck, 'Enable', 'on');
set(handles.edit_AnzahlAnfangswerte_Rechteck, 'Enable', 'on');
set(handles.edit_AnfangswertBereichGitter, 'Enable', 'off');
set(handles.edit_AnzahlAnfangswerte_Gitter, 'Enable', 'off');
set(handles.edit_AnfangswertBereichPunkt, 'Enable', 'off');

data = getappdata(gcbf, 'Parameter');             % Parameter speichern.
data.bAnfangswertGitter = logical(0);
data.bAnfangswertRechteck = logical(1);
data.bAnfangswertPunkt = logical(0);
setappdata(gcbf, 'Parameter', data);



%========================================================================================
% radiobutton_Punkt_Callback
%========================================================================================
% --- Executes on button press in radiobutton_Punkt.
%========================================================================================
function radiobutton_Punkt_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_Punkt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(handles.radiobutton_Rechteck, 'Value', 0);
set(handles.radiobutton_Gitter, 'Value', 0);
set(handles.radiobutton_Punkt, 'Value', 1);

set(handles.edit_AnfangswertBereichRechteck, 'Enable', 'off');
set(handles.edit_AnzahlAnfangswerte_Rechteck, 'Enable', 'off');
set(handles.edit_AnfangswertBereichGitter, 'Enable', 'off');
set(handles.edit_AnzahlAnfangswerte_Gitter, 'Enable', 'off');
set(handles.edit_AnfangswertBereichPunkt, 'Enable', 'on');

data = getappdata(gcbf, 'Parameter');             % Parameter speichern.
data.bAnfangswertGitter = logical(0);
data.bAnfangswertRechteck = logical(0);
data.bAnfangswertPunkt = logical(1);
setappdata(gcbf, 'Parameter', data);



%========================================================================================
% edit_AnfangswertBereichPunkt_CreateFcn
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function edit_AnfangswertBereichPunkt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_AnfangswertBereichPunkt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%========================================================================================
% edit_AnfangswertBereichPunkt_Callback
%========================================================================================
function edit_AnfangswertBereichPunkt_Callback(hObject, eventdata, handles)
% hObject    handle to edit_AnfangswertBereichPunkt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
vAnfangswertBereich = str2num(get(hObject, 'String'));        % Eingabe holen.
data = getappdata(gcbf, 'Parameter');             % Datenstruktur holen.
if (~all(size(vAnfangswertBereich) == [1 2]))
  msgbox('Parameter fehlerhaft: Koordinaten Punkt = [Nx, Ny]', 'Fehlerhafte Eingabe', 'error');
else
  data.vAnfangswertBereichPunkt = vAnfangswertBereich;                        % Neuen Parameter speichern.
end
setappdata(gcbf, 'Parameter', data);
set(hObject, 'String', ['[  ' sprintf('%g  ', data.vAnfangswertBereichPunkt) ']']);   % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% edit_AnfangswertBereichGitter_CreateFcn
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function edit_AnfangswertBereichGitter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_AnfangswertBereichGitter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%========================================================================================
% edit_AnfangswertBereichGitter_Callback
%========================================================================================
function edit_AnfangswertBereichGitter_Callback(hObject, eventdata, handles)
% hObject    handle to edit_AnfangswertBereichGitter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
vAnfangswertBereich = str2num(get(hObject, 'String'));  % Eingabe holen.
data = getappdata(gcbf, 'Parameter');             % Datenstruktur holen.
if (all(size(vAnfangswertBereich) == [1 4]) == logical(0))
  msgbox('Parameter fehlerhaft: Gitterbereich = [xmin, xmax, ymin, ymax]', 'Fehlerhafte Eingabe', 'error');
elseif ((vAnfangswertBereich(2) < vAnfangswertBereich (1)) | (vAnfangswertBereich (4) < vAnfangswertBereich(3) > 0))
  msgbox('Parameter fehlerhaft: Gitterbereich = [xmin, xmax, ymin, ymax]', 'Fehlerhafte Eingabe', 'error');
else
  data.vAnfangswertBereichGitter = vAnfangswertBereich;                        % Neuen Parameter speichern.
end
setappdata(gcbf, 'Parameter', data);
set(hObject, 'String', ['[  ' sprintf('%g  ', data.vAnfangswertBereichGitter) ']']);   % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% edit_AnzahlAnfangswerte_Gitter_CreateFcn
%========================================================================================
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function edit_AnzahlAnfangswerte_Gitter_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_AnzahlAnfangswerte_Gitter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



%========================================================================================
% edit_AnzahlAnfangswerte_Gitter_Callback
%========================================================================================
function edit_AnzahlAnfangswerte_Gitter_Callback(hObject, eventdata, handles)
% hObject    handle to edit_AnzahlAnfangswerte_Gitter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
vAnzahlAnfangswerte = str2num(get(hObject, 'String'));        % Eingabe holen.
data = getappdata(gcbf, 'Parameter');             % Datenstruktur holen.
if (all(size(vAnzahlAnfangswerte) == [1 2]) == logical(0))
  msgbox('Parameter fehlerhaft: Anzahl Anfangswerte = [Nx, Ny]', 'Fehlerhafte Eingabe', 'error');
elseif (vAnzahlAnfangswerte(1) < 0) | (vAnzahlAnfangswerte(2) < 0)
  msgbox('Parameter fehlerhaft: Anzahl Anfangswerte = [Nx, Ny]', 'Fehlerhafte Eingabe', 'error');
else
  data.vAnzahlAnfangswerteGitter = vAnzahlAnfangswerte;                        % Neuen Parameter speichern.
end
setappdata(gcbf, 'Parameter', data);
set(hObject, 'String', ['[  ' sprintf('%g  ', data.vAnzahlAnfangswerteGitter) ']']);   % Umgewandelte Eingabe zur Kontrolle angeben.



%========================================================================================
% pushbutton_AuswahlMaus_Callback
%========================================================================================
% --- Executes on button press in pushbutton_AuswahlMaus.
%========================================================================================
function pushbutton_AuswahlMaus_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_AuswahlMaus (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% -== Nur durchfhren, wenn ein aktuelles Diagramm gefnet ist ==- %
if (~isempty(get(0,'CurrentFigure')))
  % -== Grafische Eingabe der Koordinaten fr die Trajektorie ==- %
  [x, y] = ginput(1);
  
  % -== Daten fr den neuen Punkt speichern ==- %
  data = getappdata(gcbf, 'Parameter');             % Datenstruktur holen.
  data.vAnfangswertBereichPunkt = [x, y];           % Ausgelesene Koordinaten speichern.
  data.bNeuesDiagramm = logical(0);                      % Aktuelles Diagramm weiterbenutzen.
  data.bAnfangswertGitter = logical(0);                  % Anfangspunkt aktivieren.
  data.bAnfangswertRechteck = logical(0);
  data.bAnfangswertPunkt = logical(1);
  setappdata(gcbf, 'Parameter', data);

  % -== Aktuelle Daten anzeigen ==- %
  showdata(handles, data);
  pushbutton_Berechnen_Callback(hObject, eventdata, handles);
end



%========================================================================================
% popupmenu_Beispiele_CreateFcn
%========================================================================================
% --- Executes during object creation, after setting all properties.
%========================================================================================
function popupmenu_Beispiele_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_Beispiele (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


%========================================================================================
% popupmenu_Beispiele_Callback
%========================================================================================
% --- Executes on selection change in popupmenu_Beispiele.
%========================================================================================
function popupmenu_Beispiele_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_Beispiele (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu_Beispiele contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_Beispiele

% -== Abfrage, welches Beispiel ausgewhlt wurde ==- %
n = get(hObject,'Value');

switch n
  case 1
    % -== Systemgleichung ==- %
    data.sDX1 = 'x2';
    data.sDX2 = '-x1 + (1 - x1^2) * x2';
    % -== Allgemeine Parameter ==- %
    data.vBereich = [-3, 3, -3, 3];
    data.vLaufzeit = [-8, 18];
    data.bNeuesDiagramm = logical(1);
    % -== Anfangswerte ==- %
    data.bAnfangswertGitter = logical(0);
    data.bAnfangswertRechteck = logical(0);
    data.bAnfangswertPunkt = logical(1);
    data.vAnfangswertBereichGitter = [-3, 3, -3, 3];
    data.vAnzahlAnfangswerteGitter = [4, 4];
    data.vAnfangswertBereichRechteck = [-3, 3, -3, 3];
    data.vAnzahlAnfangswerteRechteck = [5, 5];
    data.vAnfangswertBereichPunkt = [1, 1];
    % -== Pfeile ==- %
    data.LaengePfeil = 1;

    % -== Parameter speichern ==- %
    setappdata(gcbf, 'Parameter', data);

    % -== Aktuelle Daten anzeigen ==- %
    showdata(handles, data);

  case 2
    % -== Systemgleichung ==- %
    data.sDX1 = 'x1 * (x2 - 1)';
    data.sDX2 = 'x2 * (x1 - 1)';
    % -== Allgemeine Parameter ==- %
    data.vBereich = [-2, 2, -2, 2];
    data.vLaufzeit = [-3, 10];
    data.bNeuesDiagramm = logical(1);
    % -== Anfangswerte ==- %
    data.bAnfangswertGitter = logical(0);
    data.bAnfangswertRechteck = logical(1);
    data.bAnfangswertPunkt = logical(0);
    data.vAnfangswertBereichGitter = [-2, 2, -2, 2];
    data.vAnzahlAnfangswerteGitter = [5, 5];
    data.vAnfangswertBereichRechteck = [-2, 1.5, -2, 1.5];
    data.vAnzahlAnfangswerteRechteck = [9, 9];
    data.vAnfangswertBereichPunkt = [-1, -2];
    % -== Pfeile ==- %
    data.LaengePfeil = 1.5;

    % -== Parameter speichern ==- %
    setappdata(gcbf, 'Parameter', data);

    % -== Aktuelle Daten anzeigen ==- %
    showdata(handles, data);

  case 3
    % -== Systemgleichung ==- %
    data.sDX1 = 'x2';
    data.sDX2 = 'x1';
    % -== Allgemeine Parameter ==- %
    data.vBereich = [-2, 2, -2, 2];
    data.vLaufzeit = [-5, 5];
    data.bNeuesDiagramm = logical(1);
    % -== Anfangswerte ==- %
    data.bAnfangswertGitter = logical(1);
    data.bAnfangswertRechteck = logical(0);
    data.bAnfangswertPunkt = logical(0);
    data.vAnfangswertBereichGitter = [-2, 2, -2, 2];
    data.vAnzahlAnfangswerteGitter = [5, 5];
    data.vAnfangswertBereichRechteck = [-2, 2, -2, 2];
    data.vAnzahlAnfangswerteRechteck = [5, 5];
    data.vAnfangswertBereichPunkt = [-1, -2];
    % -== Pfeile ==- %
    data.LaengePfeil = 1.5;

    % -== Parameter speichern ==- %
    setappdata(gcbf, 'Parameter', data);

    % -== Aktuelle Daten anzeigen ==- %
    showdata(handles, data);

  case 4
    % -== Systemgleichung ==- %
    data.sDX1 = '-x1 + x2';
    data.sDX2 = '-x1 - 2 * x2';
    % -== Allgemeine Parameter ==- %
    data.vBereich = [-2, 2, -2, 2];
    data.vLaufzeit = [0, 5];
    data.bNeuesDiagramm = logical(1);
    % -== Anfangswerte ==- %
    data.bAnfangswertGitter = logical(0);
    data.bAnfangswertRechteck = logical(1);
    data.bAnfangswertPunkt = logical(0);
    data.vAnfangswertBereichGitter = [-2, 2, -2, 2];
    data.vAnzahlAnfangswerteGitter = [5, 5];
    data.vAnfangswertBereichRechteck = [-2, 2, -2, 2];
    data.vAnzahlAnfangswerteRechteck = [5, 4];
    data.vAnfangswertBereichPunkt = [-1, -2];
    % -== Pfeile ==- %
    data.LaengePfeil = 1.5;

    % -== Parameter speichern ==- %
    setappdata(gcbf, 'Parameter', data);

    % -== Aktuelle Daten anzeigen ==- %
    showdata(handles, data);
    
  case 5
    % -== Systemgleichung ==- %
    data.sDX1 = 'x2';
    data.sDX2 = '-x1';
    % -== Allgemeine Parameter ==- %
    data.vBereich = [-2, 2, -2, 2];
    data.vLaufzeit = [0, 3.1];
    data.bNeuesDiagramm = logical(1);
    % -== Anfangswerte ==- %
    data.bAnfangswertGitter = logical(1);
    data.bAnfangswertRechteck = logical(0);
    data.bAnfangswertPunkt = logical(0);
    data.vAnfangswertBereichGitter = [0, 0, -1.9, 1.9];
    data.vAnzahlAnfangswerteGitter = [1, 8];
    data.vAnfangswertBereichRechteck = [-2, 2, -2, 2];
    data.vAnzahlAnfangswerteRechteck = [4, 4];
    data.vAnfangswertBereichPunkt = [-1, -2];
    % -== Pfeile ==- %
    data.LaengePfeil = 1.5;

    % -== Parameter speichern ==- %
    setappdata(gcbf, 'Parameter', data);

    % -== Aktuelle Daten anzeigen ==- %
    showdata(handles, data);
    
  case 6
    % -== Systemgleichung ==- %
    data.sDX1 = 'x2';
    data.sDX2 = '1';
    % -== Allgemeine Parameter ==- %
    data.vBereich = [-2, 2, -2, 2];
    data.vLaufzeit = [-3, 3];
    data.bNeuesDiagramm = logical(1);
    % -== Anfangswerte ==- %
    data.bAnfangswertGitter = logical(0);
    data.bAnfangswertRechteck = logical(1);
    data.bAnfangswertPunkt = logical(0);
    data.vAnfangswertBereichGitter = [-2, 2, -2, 2];
    data.vAnzahlAnfangswerteGitter = [4, 4];
    data.vAnfangswertBereichRechteck = [-3, 1.9, 0, 0];
    data.vAnzahlAnfangswerteRechteck = [7, 1];
    data.vAnfangswertBereichPunkt = [-1, -2];
    % -== Pfeile ==- %
    data.LaengePfeil = 1.5;

    % -== Parameter speichern ==- %
    setappdata(gcbf, 'Parameter', data);

    % -== Aktuelle Daten anzeigen ==- %
    showdata(handles, data);
    
  case 7
    % -== Systemgleichung ==- %
    data.sDX1 = 'x2';
    data.sDX2 = '-1';
    % -== Allgemeine Parameter ==- %
    data.vBereich = [-2, 2, -2, 2];
    data.vLaufzeit = [-3, 3];
    data.bNeuesDiagramm = logical(1);
    % -== Anfangswerte ==- %
    data.bAnfangswertGitter = logical(0);
    data.bAnfangswertRechteck = logical(1);
    data.bAnfangswertPunkt = logical(0);
    data.vAnfangswertBereichGitter = [-2, 2, -2, 2];
    data.vAnzahlAnfangswerteGitter = [4, 4];
    data.vAnfangswertBereichRechteck = [-1.9, 3, 0, 0];
    data.vAnzahlAnfangswerteRechteck = [7, 1];
    data.vAnfangswertBereichPunkt = [-1, -2];
    % -== Pfeile ==- %
    data.LaengePfeil = 1.5;

    % -== Parameter speichern ==- %
    setappdata(gcbf, 'Parameter', data);

    % -== Aktuelle Daten anzeigen ==- %
    showdata(handles, data);
    
  case 8
    % -== Systemgleichung ==- %
    data.sDX1 = 'x2';
    data.sDX2 = '9.81 * sin(x1) - 2 * x2';
    % -== Allgemeine Parameter ==- %
    data.vBereich = [-12, 12, -12, 12];
    data.vLaufzeit = [-6, 6];
    data.bNeuesDiagramm = logical(1);
    % -== Anfangswerte ==- %
    data.bAnfangswertGitter = logical(1);
    data.bAnfangswertRechteck = logical(0);
    data.bAnfangswertPunkt = logical(0);
    data.vAnfangswertBereichGitter = [-12, 12, -12, 12];
    data.vAnzahlAnfangswerteGitter = [5, 5];
    data.vAnfangswertBereichRechteck = [-12, 12, -12, 12];
    data.vAnzahlAnfangswerteRechteck = [7, 7];
    data.vAnfangswertBereichPunkt = [-1, -2];
    % -== Pfeile ==- %
    data.LaengePfeil = 1;

    % -== Parameter speichern ==- %
    setappdata(gcbf, 'Parameter', data);

    % -== Aktuelle Daten anzeigen ==- %
    showdata(handles, data);
    
  case 9
    % -== Systemgleichung ==- %
    data.sDX1 = 'x1 * (x2 - 1)';
    data.sDX2 = 'x2 * (x1 - 1)';
    % -== Allgemeine Parameter ==- %
    data.vBereich = [-2, 2, -2, 2];
    data.vLaufzeit = [0, 0.001];
    data.bNeuesDiagramm = logical(1);
    % -== Anfangswerte ==- %
    data.bAnfangswertGitter = logical(1);
    data.bAnfangswertRechteck = logical(0);
    data.bAnfangswertPunkt = logical(0);
    data.vAnfangswertBereichGitter = [-2, 2, -2, 2];
    data.vAnzahlAnfangswerteGitter = [25, 25];
    data.vAnfangswertBereichRechteck = [-1, 1, -1, 1];
    data.vAnzahlAnfangswerteRechteck = [7, 7];
    data.vAnfangswertBereichPunkt = [-1, -2];
    % -== Pfeile ==- %
    data.LaengePfeil = 0.75;

    % -== Parameter speichern ==- %
    setappdata(gcbf, 'Parameter', data);

    % -== Aktuelle Daten anzeigen ==- %
    showdata(handles, data);
end



%========================================================================================
% figure1_DeleteFcn
%========================================================================================
% --- Executes during object deletion, before destroying properties.
%========================================================================================
function figure1_DeleteFcn(hObject, eventdata, handles)

%cd ..



%========================================================================================
% pushbutton_Hilfe_Callback
%========================================================================================
% --- Executes during object deletion, before destroying properties.
%========================================================================================
function pushbutton_Hilfe_Callback(hObject, eventdata, handles)

open hilfe.pdf


% --- Executes during object creation, after setting all properties.
function text67_CreateFcn(hObject, eventdata, handles)
% hObject    handle to text67 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes during object creation, after setting all properties.
function frame5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to frame5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


